/* R[h͂rihr sR[h͂bqke */
/* $Id: TunedFunc_x86.cpp 950 2012-10-14 09:56:14Z umezawa $ */

#include "stdafx.h"
#include "utvideo.h"
#include "TunedFunc.h"
#include "Predict.h"
#include "HuffmanCode.h"
#include "Convert.h"

#ifdef _MSC_VER
// intrin.h CN[h
// error C2733: I[o[[hꂽ֐ '_interlockedbittestandset'  C P[W 2 ȏ̐錾͋܂B
// ȂǂƃG[oB
extern "C" void __cpuid(int *, int);
#endif

const TUNEDFUNC tfnI686 = {
	cpp_PredictMedianAndCount,
	cpp_PredictMedianAndCount,
	cpp_PredictLeftAndCount,
	x86_i686_RestoreMedian_align1,
	x86_i686_HuffmanEncode,
	x86_i686_HuffmanDecode,
	x86_i686_HuffmanDecodeAndAccum,
	x86_i686_HuffmanDecodeAndAccumStep2,
	x86_i686_HuffmanDecodeAndAccumStep4,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXGreen,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXBlue,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXRedAndDummyAlpha,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRGreen,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRBlue,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBGreen,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBBlue,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBRedAndDummyAlpha,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBGreen,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBBlue,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownBGRXRedAndDummyAlpha,
	cpp_ConvertULY2ToBottomupBGR,
	cpp_ConvertULY2ToBottomupBGRX,
	cpp_ConvertULY2ToTopdownBGR,
	cpp_ConvertULY2ToTopdownBGRX,
	cpp_ConvertULY2ToTopdownRGB,
	cpp_ConvertULY2ToTopdownXRGB,
	cpp_ConvertBottomupBGRToULY2,
	cpp_ConvertBottomupBGRXToULY2,
	cpp_ConvertTopdownBGRToULY2,
	cpp_ConvertTopdownBGRXToULY2,
	cpp_ConvertTopdownRGBToULY2,
	cpp_ConvertTopdownXRGBToULY2,
	DummyTunedFunc
};

const TUNEDFUNC tfnSSE2 = {
	x86_sse2_PredictMedianAndCount_align16,
	x86_sse2_PredictMedianAndCount_align1,
	x86_sse2_PredictLeftAndCount_align1,
	x86_sse1mmx_RestoreMedian_align1,
	x86_i686_HuffmanEncode,
	x86_i686_HuffmanDecode,
	x86_i686_HuffmanDecodeAndAccum,
	x86_i686_HuffmanDecodeAndAccumStep2,
	x86_i686_HuffmanDecodeAndAccumStep4,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXGreen,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXBlue,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForBottomupBGRXRedAndDummyAlpha,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRGreen,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRBlue,
	x86_i686_HuffmanDecodeAndAccumStep3ForBottomupBGRRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBGreen,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBBlue,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownXRGBRedAndDummyAlpha,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBGreen,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBBlue,
	x86_i686_HuffmanDecodeAndAccumStep3ForTopdownRGBRed,
	x86_i686_HuffmanDecodeAndAccumStep4ForTopdownBGRXRedAndDummyAlpha,
	x86_sse2_ConvertULY2ToBottomupBGR,
	x86_sse2_ConvertULY2ToBottomupBGRX,
	x86_sse2_ConvertULY2ToTopdownBGR,
	x86_sse2_ConvertULY2ToTopdownBGRX,
	x86_sse2_ConvertULY2ToTopdownRGB,
	x86_sse2_ConvertULY2ToTopdownXRGB,
	x86_sse2_ConvertBottomupBGRToULY2,
	x86_sse2_ConvertBottomupBGRXToULY2,
	x86_sse2_ConvertTopdownBGRToULY2,
	x86_sse2_ConvertTopdownBGRXToULY2,
	x86_sse2_ConvertTopdownRGBToULY2,
	x86_sse2_ConvertTopdownXRGBToULY2,
	DummyTunedFunc
};

const TUNEDFUNC &tfnSSE3 = tfnSSE2;

const TUNEDFUNC &tfnSSSE3 = tfnSSE2;

const TUNEDFUNC &tfnSSE41 = tfnSSE2;

const TUNEDFUNC &tfnSSE42 = tfnSSE2;

class CTunedFuncInitializer
{
public:
	CTunedFuncInitializer()
	{
		uint32_t cpuid_1_ecx = 0;
		uint32_t cpuid_1_edx = 0;

#if defined(_MSC_VER)
		int info[4];
		__cpuid(info, 0);
		if (info[0] >= 1)
		{
			__cpuid(info, 1);
			cpuid_1_ecx = info[2];
			cpuid_1_edx = info[3];
		}
#elif defined(__GNUC__)
		int tmp0, tmp1;
		asm volatile (
			"cpuid"
			: "=a"(tmp0), "=b"(tmp1), "=c"(cpuid_1_ecx), "=d"(cpuid_1_edx)
			: "a"(1)
		);
#else
#error
#endif

		_RPT2(_CRT_WARN, "CPUID.1 ECX=%08X EDX=%08X\n", cpuid_1_ecx, cpuid_1_edx);

		if (cpuid_1_ecx & (1 << 20))
		{
			_RPT0(_CRT_WARN, "supports SSE4.2\n");
			tfn = tfnSSE42;
		}
		else if (cpuid_1_ecx & (1 << 19))
		{
			_RPT0(_CRT_WARN, "supports SSE4.1\n");
			tfn = tfnSSE41;
		}
		else if (cpuid_1_ecx & (1 << 9))
		{
			_RPT0(_CRT_WARN, "supports SSSE3\n");
			tfn = tfnSSSE3;
		}
		else if (cpuid_1_ecx & (1 << 0))
		{
			_RPT0(_CRT_WARN, "supports SSE3\n");
			tfn = tfnSSE3;
		}
		else if (cpuid_1_edx & (1 << 26))
		{
			_RPT0(_CRT_WARN, "supports SSE2\n");
			tfn = tfnSSE2;
		}
		else
		{
			_RPT0(_CRT_WARN, "supports no SSE-integer\n");
			tfn = tfnI686;
		}
	}
} tfi;
